/*
  manaemori --- a keeperhack for manae
  manaemori.c --- manaemori main module
  Copyright 2000-2002 IWAMA Naozumi
  This file is written in SJIS.
  ̃t@C SJIS ŋLqĂ܂B
  manaemori hacks SysHandleEvent.
*/

#include <PalmOS.h>
#include <HandEra/Trg.h>
#include <HandEra/TrgChars.h>
#include <Sony/System/SonyChars.h>
#include "manae.h"
#include "manaemori.h"
#include "myfunc.h"

// mmprefs.c
Err MMPrefsGet(ManaeMoriPrefsType *mmPrefs);

// #define DEBUG
GlobalPtr ManaeStart(void);
Err ManaeStop(GlobalPtr g);

// init.c
Boolean DComplForceEnd(GlobalPtr g);

// macro
#define C(I) ((CTPtr)((ULong)g->dcP->cands + (ULong)(sizeof(CT)) * (ULong)I))

/*
static ManaeMoriGlobalType *ManaeMoriNewGlobal(void)
{
  ManaeMoriGlobalType *gP;
  Int16 i;

  if ((gP = MemPtrNew(sizeof(ManaeMoriGlobalType))) == NULL) {
    return(NULL); // temporaly.
  }

  // Clear memory.
  for (i = 0; i < sizeof(ManaeMoriGlobalType); i++) {
    *((Byte *)gP + i) = 0;
  }

  MemPtrSetOwner(gP, 0); // Never Garbage collected.
  return(gP);
}
*/

/*
static ManaeMoriGlobalType *ManaeMoriStart()
{
  GlobalPtr manaeGP;
  ManaeMoriGlobalType *gP;

  if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&manaeGP) != 0) {
    // no such feature. manae is not running.
    return(NULL); // do nothing.
  }
  
  if ((gP = ManaeMoriNewGlobal()) == NULL) {
    ErrDisplay("Cannot new globals");
    return(NULL);
  }
  return(gP);
}
*/

static UInt16 EmacsKeyTrans(UInt16 c)
{
  UInt16 transC;

  switch (c) {
  case ('f' - 'a' + 1):
  case 0x0109:
    transC = rightArrowChr;
    break;
  case ('b' - 'a' + 1):
  case 0x0101:
    transC = leftArrowChr;
    break;
  case ('p' - 'a' + 1):
    transC = upArrowChr;
    break;
  case ('n' - 'a' + 1):
  case 0x0103:
    transC = downArrowChr;
    break;
/* don't work...sigh...
  case ('s' - 'a' + 1):
    transC = findChr;
    break;
  case ('w' - 'a' + 1):
    transC = cutChr;
    break;
  case ('y' - 'a' + 1):
    transC = pasteChr;
    break;
*/
  default:
    transC = c;
    break;
  }
  return(transC);
}

Boolean ManaeMoriPenDown(EventPtr eventP, GlobalPtr g)
{

#ifdef DEBUG
  ErrorPrintNum(eventP->screenX, 80, 10);
  ErrorPrintNum(eventP->screenY, 120, 10);
#endif

  if (g->dcP == NULL) {
    return(false);
  }

  if (C(0)->dicType == NODIC) {
    return(false);
  }

#ifdef DEBUG
    ErrorPrintHex(g->frm, 0, 150);
    ErrorPrintHex(FrmGetActiveForm(), 80, 150);
#endif
  if (g->frm == FrmGetActiveForm()) {
    return(true);
  }
  return(false);
}

Boolean ManaeMoriPenUp(EventPtr eventP, GlobalPtr g)
{
  Int16 i;

  if (g->dcP == NULL) return(false);

  if (C(0)->dicType == NODIC) {
    return(false);
  }

#ifdef DEBUG
  ErrorPrintNum(eventP->screenX, 80, 10);
  ErrorPrintNum(eventP->screenY, 120, 10);
#endif

  if (g->frm != FrmGetActiveForm()) {
    return(false);
  }

  for (i = 0; i < 3; i++) {

#ifdef DEBUG
    ErrorPrintNum(g->dcP->c[i].topLeft.x, 0, 10 + 10 * i);
    ErrorPrintNum(g->dcP->c[i].extent.x, 40, 10 + 10 * i);
    ErrorPrintNum(g->dcP->c[i].topLeft.y, 80, 10 + 10 * i);
    ErrorPrintNum(g->dcP->c[i].extent.y, 120, 10 + 10 * i);
#endif

    if ((g->dcP->c[i].topLeft.x < eventP->screenX) &&
	((g->dcP->c[i].topLeft.x + g->dcP->c[i].extent.x) >
	 g->event->screenX) &&
	(g->dcP->c[i].topLeft.y  < eventP->screenY) &&
	((g->dcP->c[i].topLeft.y + g->dcP->c[i].extent.y) >
	 g->event->screenY)) {
      ManaeMoriPrefsType mmPrefs;
      MMPrefsGet(&mmPrefs);
      if (mmPrefs.tap == true) {      
	EvtEnqueueKey(i + '1', 0, 0);
	return(true);
      }
    }
  }
  return(false);
}

UInt16 KeyTrans2(EventType *eventP, GlobalPtr g)
{
  switch (g->kanjiMode) {
  case KANJI:
  case KANJIIN:
    switch (eventP->data.keyDown.chr) {
    case vchrTrgJogUp:
    case vchrJogUp:
    case vchrHard2:
      g->realChr = '1';
      eventP->data.keyDown.chr = '1';
      break;
	    
    case vchrTrgJogDown:
    case vchrJogDown:
    case vchrHard3:
      g->realChr = '3';
      eventP->data.keyDown.chr = '3';
      break;

    case vchrTrgJogPush:
    case vchrJogPush:
    case vchrPageUp:
      g->realChr = '2';
      eventP->data.keyDown.chr = '2';
      break;

    case vchrTrgAux:
    case vchrJogBack:
    case vchrPageDown:
      g->realChr = ' ';
      eventP->data.keyDown.chr = ' ';
      break;
	    
    default:
      break;
    }
    break;
	  
  case OKURIIN:
    break;

  case HENKAN:
    switch (eventP->data.keyDown.chr) {
    case vchrTrgJogUp:
    case vchrJogUp:
    case vchrPageUp:
      g->realChr = 'x';
      eventP->data.keyDown.chr = 'x';
      return(false);
      break;
	    
    case vchrTrgJogDown:
    case vchrJogDown:
    case vchrPageDown:
      g->realChr = ' ';
      eventP->data.keyDown.chr = ' ';
      return(false);
      break;

    case vchrTrgJogPush:
    case vchrJogPush:
    case vchrHard2:
    case vchrHard3:
      g->realChr = linefeedChr;
      eventP->data.keyDown.chr = linefeedChr;
      return(false);
      break;

    case vchrTrgAux:
    case vchrJogBack:
      g->realChr =  ' ';
      eventP->data.keyDown.chr = ' ';
      return(false);
      break;
	    
    default:
      break;
    }
    break;

  case NONKANJI:
    if ((g->mode == HIRA) ||
	(g->mode == KATA)) {
      switch (eventP->data.keyDown.chr) {
      case linefeedChr:
	g->realChr = eventP->data.keyDown.chr;
	eventP->data.keyDown.chr = crChr;
	break;
	  
      case vchrTrgJogUp:
      case vchrJogUp:
	// Do Nothing.
	//	  g->realChr = eventP->data.keyDown.chr;
	//	  eventP->data.keyDown.chr = backspaceChr;
	break;
	    
      case vchrTrgJogDown:
      case vchrJogDown:
	// Do Nothing.
	//	  g->realChr = eventP->data.keyDown.chr;
	//	  eventP->data.keyDown.chr = backspaceChr;
	break;

      case vchrTrgJogPush:
      case vchrJogPush:
      case vchrHard1:
      case vchrHard4:
	g->realChr = 'Q';
	eventP->data.keyDown.chr = 'Q';
	break;

      case vchrTrgAux:
      case vchrJogBack:
      case vchrHard2:
      case vchrHard3:
	g->realChr = 'l';
	eventP->data.keyDown.chr = 'l';
	break;
	
      default:
	break;
      }
    }
    break;
	  
  default:
    // do nothing
    break;
  }
  return(g->realChr);
}

UInt16 KeyTrans(EventType *eventP, GlobalPtr g)
{
  ManaeMoriPrefsType mmPrefs;
  UInt16 ret;

  ret = 0;

  if ((eventP->data.keyDown.chr >= vchrSonyMin) &&
      (eventP->data.keyDown.chr <= vchrSonyMax)) {
    MMPrefsGet(&mmPrefs);
    if (mmPrefs.jog == true) {
      ret = KeyTrans2(eventP, g);
    }
  }
  else if ((eventP->data.keyDown.chr >= vchrCFlashMin) &&
	   (eventP->data.keyDown.chr <= vchrCFlashMax)) {
    MMPrefsGet(&mmPrefs);
    if (mmPrefs.jog == true) {
      ret = KeyTrans2(eventP, g);
    }
  }
  else if (((eventP->data.keyDown.chr >= hardKeyMin) &&
	    (eventP->data.keyDown.chr <= hardKeyMax)) ||
	   (eventP->data.keyDown.chr == vchrPageUp) ||
	   (eventP->data.keyDown.chr == vchrPageDown)) {
    MMPrefsGet(&mmPrefs);
    if (mmPrefs.hardKey == true) {
      ret = KeyTrans2(eventP, g);
    }
  }
  return(ret);
}

Boolean ManaeMori(EventPtr eventP)
{
  UInt32 ftrVal;
  Boolean (*oldtrap)(EventPtr);
  Boolean ret;
  GlobalPtr g;
  UInt16 c;

  FtrGet(MMCREATOR, 1000, &ftrVal);
  oldtrap = (Boolean (*)(EventPtr))ftrVal;

  if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g) != 0) { 
    // manae doesn't run.
    if (eventP->eType == frmOpenEvent) {
      //      g = ManaeStart();
    }
    ret = (*oldtrap)(eventP);
    return(ret);
  }

  // manae is running.
  g->realChr = nullChr;
  
  if (eventP->eType == frmLoadEvent) {
    if (g->candsFrmFlg == true) {
    } else {
      ManaeStop(g);
    }
  }

  if (eventP->eType == appStopEvent) {
    //    ErrFatalDisplay("app stop");
    if (g->dcP != NULL) {
      // Do Nothing!!!!!!!!!
      DComplForceEnd(g);
      return(false);
    }
    ManaeStop(g);
    ret = (*oldtrap)(eventP);
    return(ret);
  }

  if (eventP->eType == penDownEvent) {
    if (ManaeMoriPenDown(eventP, g) == true) {
      return(true);
    } else {
      ret = (*oldtrap)(eventP);
      return(ret);
    }
  }

  if (eventP->eType == penUpEvent) {
    if (ManaeMoriPenUp(eventP, g) == true) {
      return(true);
    } else {
      ret = (*oldtrap)(eventP);
      return(ret);
    }
  }

  if (eventP->eType != keyDownEvent) {
    ret = (*oldtrap)(eventP);
    return(ret);
  }

  if ((c = EmacsKeyTrans(eventP->data.keyDown.chr)) != 
      eventP->data.keyDown.chr) {
    eventP->data.keyDown.chr = c;
    eventP->data.keyDown.modifiers = 0;
    ret = (*oldtrap)(eventP);
    return(ret);
  }
  KeyTrans(eventP, g);

  /*  
  switch (g->kanjiMode) {
  case KANJI:
  case KANJIIN:
    switch (eventP->data.keyDown.chr) {
    case vchrTrgJogUp:
    case vchrJogUp:
    case vchrHard2:
      g->realChr = '1';
      eventP->data.keyDown.chr = '1';
      break;
	    
    case vchrTrgJogDown:
    case vchrJogDown:
    case vchrHard3:
      g->realChr = '3';
      eventP->data.keyDown.chr = '3';
      break;

    case vchrTrgJogPush:
    case vchrJogPush:
    case vchrPageUp:
      g->realChr = '2';
      eventP->data.keyDown.chr = '2';
      break;

    case vchrTrgAux:
    case vchrJogBack:
    case vchrPageDown:
      g->realChr = ' ';
      eventP->data.keyDown.chr = ' ';
      break;
	    
    default:
      break;
    }
    break;
	  
  case OKURIIN:
    break;

  case HENKAN:
    switch (eventP->data.keyDown.chr) {
    case vchrTrgJogUp:
    case vchrJogUp:
    case vchrPageUp:
      g->realChr = 'x';
      eventP->data.keyDown.chr = 'x';
      return(false);
      break;
	    
    case vchrTrgJogDown:
    case vchrJogDown:
    case vchrPageDown:
      g->realChr = ' ';
      eventP->data.keyDown.chr = ' ';
      return(false);
      break;

    case vchrTrgJogPush:
    case vchrJogPush:
    case vchrHard2:
    case vchrHard3:
      g->realChr = linefeedChr;
      eventP->data.keyDown.chr = linefeedChr;
      return(false);
      break;

    case vchrTrgAux:
    case vchrJogBack:
      g->realChr =  ' ';
      eventP->data.keyDown.chr = ' ';
      return(false);
      break;
	    
    default:
      break;
    }
    break;

  case NONKANJI:
    if ((g->mode == HIRA) ||
	(g->mode == KATA)) {
      switch (eventP->data.keyDown.chr) {
      case linefeedChr:
	g->realChr = eventP->data.keyDown.chr;
	eventP->data.keyDown.chr = crChr;
	break;
	  
      case vchrTrgJogUp:
      case vchrJogUp:
	// Do Nothing.
	//	  g->realChr = eventP->data.keyDown.chr;
	//	  eventP->data.keyDown.chr = backspaceChr;
	break;
	    
      case vchrTrgJogDown:
      case vchrJogDown:
	// Do Nothing.
	//	  g->realChr = eventP->data.keyDown.chr;
	//	  eventP->data.keyDown.chr = backspaceChr;
	break;

      case vchrTrgJogPush:
      case vchrJogPush:
      case vchrHard1:
      case vchrHard4:
	g->realChr = 'Q';
	eventP->data.keyDown.chr = 'Q';
	break;

      case vchrTrgAux:
      case vchrJogBack:
      case vchrHard2:
      case vchrHard3:
	g->realChr = 'l';
	eventP->data.keyDown.chr = 'l';
	break;
	
      default:
	break;
      }
    }
    break;
	  
  default:
    // do nothing
    break;
  }
  */

  // Closing...
  ret = (*oldtrap)(eventP);
  return(ret);
}



/*************************************************************************
**************************************************************************
Boolean ManaeMori(EventPtr eventP)
{
  DWord ftrVal;
  Boolean (*oldtrap)(EventPtr);
  Boolean ret;
  GlobalPtr g;
  DWord keymapPtr; // ???
  Word c;

  FtrGet(MMCREATOR, 1000, &ftrVal);
  oldtrap = (Boolean (*)(EventPtr))ftrVal;

  if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g) != 0) { 
    // manae doesn't run.
    if (eventP->eType == frmOpenEvent) {
      //      g = ManaeStart();
    }
    ret = (*oldtrap)(eventP);
    return(ret);
  }

  // manae is running.
  g->realChr = nullChr;
  
  if (eventP->eType == frmLoadEvent) {
    if (g->candsFrmFlg == true) {
    } else {
      ManaeStop(g);
    }
  }

  if (eventP->eType == appStopEvent) {
    //    ErrFatalDisplay("app stop");
    if (g->dcP != NULL) {
      // Do Nothing!!!!!!!!!
      DComplForceEnd(g);
      return(false);
    }
    ManaeStop(g);
    ret = (*oldtrap)(eventP);
    return(ret);
  }

  if (eventP->eType == penDownEvent) {
    if (ManaeMoriPenDown(eventP, g) == true) {
      return(true);
    } else {
      ret = (*oldtrap)(eventP);
      return(ret);
    }
  }

  if (eventP->eType == penUpEvent) {
    if (ManaeMoriPenUp(eventP, g) == true) {
      return(true);
    } else {
      ret = (*oldtrap)(eventP);
      return(ret);
    }
  }

  if (eventP->eType != keyDownEvent) {
    ret = (*oldtrap)(eventP);
    return(ret);
  }

#ifdef DEBUG
  {

    DWord c;

    FtrGet(CREATOR, 1051, &c);
    ErrorPrintHex(c, 0, 0);
    c++;
    FtrSet(CREATOR, 1051, c);
    ErrorPrintHex((ULong)eventP->data.keyDown.chr, 80, 0);
    switch (eventP->data.keyDown.chr) {

    case chrEscape:
      ErrorPrint("chrEscape", 100, 10);
      break;

    case chrBell:
      ErrorPrint("chrBell", 100, 10);
      break;

    case vchrTrgJogUp:
      ErrorPrint("vchrTrgJogUp", 100, 0);
      break;

    case vchrTrgJogDown:
      ErrorPrint("vchrTrgJogDown", 100, 0);
      break;
	
    case vchrTrgJogPush:
      ErrorPrint("vchrTrgJogPush", 100, 0);
      break;

    case vchrTrgAux:
      ErrorPrint("vchrTrgAux", 100, 0);
      break;

    case vchrTRGVolume:
      ErrorPrint("vchrTRGVolume", 100, 0);
      break;

    case vchrSilkToggle:
      ErrorPrint("vchrSilkTogle", 100, 0);
      break;

    default:
      break;
    }
  }
#endif

  if ((c = EmacsKeyTrans(eventP->data.keyDown.chr)) != 
      eventP->data.keyDown.chr) {
    eventP->data.keyDown.chr = c;
    eventP->data.keyDown.modifiers = 0;
    ret = (*oldtrap)(eventP);
    return(ret);
  }

  // Check HandEra 330
  if (FtrGet(TRGSysFtrID, TRGKeyFtrNum, &keymapPtr) == 0) {
    // for HanEra
    switch (g->kanjiMode) {
    case KANJI:
    case KANJIIN:
      switch (eventP->data.keyDown.chr) {
      case vchrTrgJogUp:
      case vchrJogUp:
      case vchrHard2:
	g->realChr = '1';
	eventP->data.keyDown.chr = '1';
	break;
	    
      case vchrTrgJogDown:
      case vchrJogDown:
      case vchrHard3:
	g->realChr = '3';
	eventP->data.keyDown.chr = '3';
	break;

      case vchrTrgJogPush:
      case vchrJogPush:
      case vchrPageUp:
	g->realChr = '2';
	eventP->data.keyDown.chr = '2';
	break;

      case vchrTrgAux:
      case vchrJogBack:
      case vchrPageDown:
	g->realChr = ' ';
	eventP->data.keyDown.chr = ' ';
	break;
	    
      default:
	break;
      }
      break;
	  
    case OKURIIN:
      break;

    case HENKAN:
      switch (eventP->data.keyDown.chr) {
      case vchrTrgJogUp:
      case vchrJogUp:
      case vchrPageUp:
	g->realChr = 'x';
	eventP->data.keyDown.chr = 'x';
	return(false);
	break;
	    
      case vchrTrgJogDown:
      case vchrJogDown:
      case vchrPageDown:
	g->realChr = ' ';
	eventP->data.keyDown.chr = ' ';
	return(false);
	break;

      case vchrTrgJogPush:
      case vchrJogPush:
      case vchrHard2:
      case vchrHard3:
	g->realChr = linefeedChr;
	eventP->data.keyDown.chr = linefeedChr;
	return(false);
	break;

      case vchrTrgAux:
      case vchrJogBack:
	g->realChr =  ' ';
	eventP->data.keyDown.chr = ' ';
	return(false);
	break;
	    
      default:
	break;
      }
      break;

    case NONKANJI:
      if ((g->mode == HIRA) ||
	  (g->mode == KATA)) {
	switch (eventP->data.keyDown.chr) {
	case linefeedChr:
	  g->realChr = eventP->data.keyDown.chr;
	  eventP->data.keyDown.chr = crChr;
	  break;
	  
	case vchrTrgJogUp:
	case vchrJogUp:
	  // Do Nothing.
	  //	  g->realChr = eventP->data.keyDown.chr;
	  //	  eventP->data.keyDown.chr = backspaceChr;
	  break;
	    
	case vchrTrgJogDown:
	case vchrJogDown:
	  // Do Nothing.
	  //	  g->realChr = eventP->data.keyDown.chr;
	  //	  eventP->data.keyDown.chr = backspaceChr;
	  break;

	case vchrTrgJogPush:
	case vchrJogPush:
	case vchrHard1:
	case vchrHard4:
	  g->realChr = 'Q';
	  eventP->data.keyDown.chr = 'Q';
	  break;

	case vchrTrgAux:
	case vchrJogBack:
	case vchrHard2:
	case vchrHard3:
	  g->realChr = 'l';
	  eventP->data.keyDown.chr = 'l';
	break;
	
	default:
	  break;
	}
      }
      break;
	  
    default:
      // do nothing
      break;
    }
  } else {
    // CLIE or other.
    switch (g->kanjiMode) {
    case KANJI:
    case KANJIIN:
      switch (eventP->data.keyDown.chr) {
      case vchrHard2:
	g->realChr = '1';
	eventP->data.keyDown.chr = '1';
	break;
	    
      case vchrHard3:
	g->realChr = '3';
	eventP->data.keyDown.chr = '3';
	break;

      case vchrPageUp:
	g->realChr = '2';
	eventP->data.keyDown.chr = '2';
	break;

      case vchrPageDown:
	g->realChr = ' ';
	eventP->data.keyDown.chr = ' ';
	break;
	    
      default:
	break;
      }
      break;

    case OKURIIN:
    case HENKAN:
      if (g->candsFrmFlg == true) {
	ret = (*oldtrap)(eventP);
	return(ret);
      }

      switch (eventP->data.keyDown.chr) {
      case vchrPageUp:
	g->realChr = 'x';
	eventP->data.keyDown.chr = 'x';
	return(false);
	break;
	    
      case vchrPageDown:
	g->realChr = ' ';
	eventP->data.keyDown.chr = ' ';
	return(false);
	break;

      case vchrHard2:
      case vchrHard3:
	g->realChr = linefeedChr;
	eventP->data.keyDown.chr = linefeedChr;
	return(false);
	break;

	g->realChr =  ' ';
	eventP->data.keyDown.chr = ' ';
	return(false);
	break;
	    
      default:
	break;
      }
      break;
      
      g->realChr = eventP->data.keyDown.chr;
      eventP->data.keyDown.chr = crChr;
	   // do not call old trap
      return(false);
      break;

    case NONKANJI:
      if ((g->mode == HIRA) ||
	  (g->mode == KATA)) {
	switch (eventP->data.keyDown.chr) {
	case linefeedChr:
	  g->realChr = eventP->data.keyDown.chr;
	  eventP->data.keyDown.chr = crChr;
	  break;
	  
	case vchrHard1:
	case vchrHard4:
	  g->realChr = 'Q';
	  eventP->data.keyDown.chr = 'Q';
	  break;

	case vchrHard2:
	case vchrHard3:
	  g->realChr = 'l';
	  eventP->data.keyDown.chr = 'l';
	break;
	
	default:
	  break;
	}
      }
      break;

    default:
      // do nothing
      break;
    }
  }

  // Closing...
  ret = (*oldtrap)(eventP);
  return(ret);
}
*/
