/* 
   manae --- skimple kana MANA Exchanger
   manaemori.h --- a header file for manaemori
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _MANAEMORI_H_
#define _MANAEMORI_H_

#include <PalmOS.h>

#define MMCREATOR 'MneM'
#define PREFFTRID 100
#define PREFID0 0
#define KEY_TRANS_TBL_SIZE 32

typedef struct {
  Boolean hardKey;
  Boolean jog;
  Boolean tap;
  Int16 reserve1;
  Int16 reserve2;
  Int16 reserve3;
  Int16 reserve4;
  Int16 deviceType;
  Int16 jogType;
} ManaeMoriPrefsType;

typedef struct {
  Int16 adv1;
  Int16 adv2;
  Int16 adv3;
  Int16 adv4;
  Int16 adv5;
  Int16 adv6;
  Int16 adv7;
  Int16 adv8;
  Int16 adv9;
  Int16 adv10;
  Int16 adv11;
  Int16 adv12;
  Int16 adv13;
  Int16 adv14;
  Int16 reserve1;
  Int16 reserve2;
  Int16 reserve3;
  Int16 reserve4;
  Int16 reserve5;
  Int16 reserve6;
  Int16 reserve7;
  Int16 reserve8;
} ManaeMoriAdvPrefsType;

typedef struct {
  ManaeMoriPrefsType *prefsP;
} ManaeMoriGlobalType;

typedef struct {
  UInt8 mode;
  UInt8 kanjiMode;
  UInt16 inputC;
  UInt16 outputC;
  UInt16 fakeC;
} KeyTransTblType;

/* Memo
   Major Mode:
   Major Mode rotation (Alphabet -> Hiragana -> Katakana)

   Alphabet Mode:
   To Hiragana Mode ()

   Hiragana Mode:
   To Katakana Mode ('q')
   
*/

#endif
