/* 
   manae --- skimple kana MANA Exchanger
   showmode.c --- for showing current mode
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _SHOWMODE_C_
#define _SHOWMODE_C_

// Now I use CheckManaemori() Only.

#include <PalmOS.h>

#include "manae.h"
#include "id.h"
#include "myfunc.h"

void ManaeOpenDB(GlobalPtr g);
void ManaeCloseDB(GlobalPtr g);

Boolean PrefsFormEvent(EventPtr e);


Boolean ShowCurrMode(Byte guiMode, GlobalPtr g)
{
  Short x, y;
  Char modeP[4];
  Coord extentX, extentY;
  Int fontHeight;
  Int fontWidth;

  WinGetDisplayExtent(&extentX, &extentY);
  WinWindowToDisplayPt(&extentX, &extentY);

  fontHeight = FntCharHeight();
  fontWidth = FntCharsWidth("", 2);

  switch (guiMode) {
  case MODETL:
    x = 0;
    y = 0;
    break;

  case MODETR:
    x = extentX - fontWidth;
    y = 0;
    break;
  case MODEBL:
    x = 0;
    y = extentY - fontHeight;
    break;
  case MODEBR:
  default:
    x = extentX - fontWidth;
    y = extentY - fontHeight;
    break;
  }

  switch (g->mode) {
  case ALPHA:
    modeP[0] = 'A';
    modeP[1] = nullChr;
    break;

  case ZEN:
    modeP[0] = 0x82;
    modeP[1] = 0x60;
    modeP[2] = nullChr;
    break;

  case HIRA:
    modeP[0] = 0x82;
    modeP[1] = 0xa0;
    modeP[2] = nullChr;
    break;

  case KATA:
    modeP[0] = 0x83;
    modeP[1] = 0x41;
    modeP[2] = nullChr;
    break;
  }

  WinDisplayToWindowPt(&x, &y);
  WinDrawChars("@", 2, x, y);
  WinDrawChars(modeP, StrLen(modeP), x, y);
  return true;
}


Boolean CheckShowMode(GlobalPtr g)
{
  //  ErrorPrintNum(g->guiMode, 110, 0);
  //  ErrorPrintNum(g->mode, 130, 0);
  if ((g->guiMode >=  MODEBR) && (g->guiMode <= MODETR)) {
    ShowCurrMode(g->guiMode, g);
    return(false);
  }
  return(false);
}
#endif
